# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
""" Copyright (c) 2000-2002 LOGILAB S.A. (Paris, FRANCE).
 http://www.logilab.fr/ -- mailto:contact@logilab.fr
 
Logilab common libraries
"""

__revision__ = "$Id: __init__.py,v 1.19 2003/09/18 08:02:16 syt Exp $"

# FIXME: move all those functions in a separated module

def intersection(list1, list2):
    """
    return the intersection of list1 and list2
    """
    intersect_dict, result = {}, []
    for item in list1:
        intersect_dict[item] = 1
    for item in list2:
        if intersect_dict.has_key(item):
            result.append(item)
    return result


def make_domains(lists):
    """
    given a list of lists, return a list of domain for each list to produce all
    combinaisons of possibles values

    ex: (['a', 'b'], ['c','d', 'e'])
       -> (['a', 'b', 'a', 'b', 'a', 'b'],
           ['c', 'c', 'd', 'd', 'e', 'e'])
    """
    domains = []
    for iterable in lists:
        new_domain = iterable[:]
        for i in range(len(domains)):
            domains[i] = domains[i]*len(iterable)
        if domains:
            missing = (len(domains[0]) - len(iterable)) / len(iterable)
            i = 0
            for j in range(len(iterable)):
                value = iterable[j]
                for dummy in range(missing):
                    new_domain.insert(i, value)
                    i += 1
                i += 1
        domains.append(new_domain)
    return domains


def flatten(iterable, results=None):
    """ flatten a list of list with any level
    """
    if results is None:
        results = []
    for val in iterable:
        if type(val) in (type(()), type([])):
            flatten(val, results)
        else:
            results.append(val)
    return results


def get_cycles(graph_dict, vertice=None, visited=None, path=None, result=None):
    ''' given a dictionnary representing an ordered graph (i.e. key are vertices
    and values is a list of destination vertices representing edges), return a
    list of detected cycles
    '''
    if not graph_dict:
        return ()
    
    if visited is None:
        visited = {}
        path = []
        result = []
        vertice = graph_dict.keys()[0]
    if visited.has_key(vertice):
        cycle = [vertice]
        for i in range(len(path)-1, -1, -1):
            node = path[i]
            cycle.insert(0, node)
            if node == vertice:
                break
        if not cycle in result:
            result.append(cycle)
        return result
    visited[vertice] = 1
    path.append(vertice)
    for node in graph_dict[vertice]:
        get_cycles(graph_dict, node, visited, path, result)
    path.pop()
    del visited[vertice]
    return result


import tempfile
import os

class Execute:
    """This is a deadlock save version of popen2 (no stdin), that returns
    an object with errorlevel,out, and err"""
    
    def __init__(self, command):
        outfile = tempfile.mktemp()
        errfile = tempfile.mktemp()
        self.status = os.system("( %s ) > %s 2> %s" %
                                    (command, outfile, errfile)) >> 8
        self.out = open(outfile,"r").read()
        self.err = open(errfile,"r").read()
        os.remove(outfile)
        os.remove(errfile)
